﻿;DebugLevel 10
XIncludeFile "Monitor.pbi"

Class(Thread)
	pause.i()
	isPaused.i()
	resume.i()
	join.i()
	isRunning.i()
	start()
	run()
	Members
		thread.i
		paused.i
		joinResult.i
		*callback
		value.i
	Constructors
		Construct(Callback, (*callback, value.i))
	Definition
		PrivateDefaultConstructor
			this\callback = 0
			this\joinResult = 0
			this\thread = 0
			this\paused = 0
		EndDefaultConstructor
		
		Constructor(Callback, (*callback, value.i))
			CallConstructor()
			this\callback = *callback
			this\value = value
		EndConstructor
		
		Deconstructor
			If IsThread(this\thread)
				KillThread(this\thread)
			EndIf
		EndDeconstructor
		
		Synchronized(pause,(this))
			If Not this\paused
				this\paused = #True
				PauseThread(this\thread)
			EndIf
			SynchronizedReturn(#True)
		EndSynchronized
		
		Synchronized(isPaused,(this))
			SynchronizedReturn(this\paused)
		EndSynchronized
		
		Synchronized(resume,(this))
			If this\paused
				ResumeThread(this\thread)
				this\paused = #False
			EndIf
		EndSynchronized
		
		Synchronized(isRunning,(this))
			SynchronizedReturn(IsThread(this\thread))
		EndSynchronized
		
		Synchronized(join,(this))
			If self\isRunning()
				WaitThread(this\thread)
			EndIf
			SynchronizedReturn(this\joinResult)
		EndSynchronized
		
		Method(run,(this))
			If this\callback
				this\joinResult = CallFunctionFast(this\callback, this\value)
			Else
				this\joinResult = child\run()
			EndIf
		EndMethod
		
		Synchronized(start,(this))
			If IsThread(this\thread)
				SynchronizedReturn(#False)
			EndIf
			this\thread = CreateThread(@run(), this)
			SynchronizedReturn(this\thread)
		EndSynchronized
EndClass

CompilerIf #PB_Compiler_IsMainFile

	#threads = 5
	
	Class(Pusher, Thread)
		Members
			number.i
		Constructors
			Construct(init,(i.i))
		Definition
			Constructor(init, (i.i))
				this\number = i
			EndConstructor
			
			Method(run,(this))
				Debug "Thread " + this\number + " started."
				Debug "Waiting for " + Str(this\number * 100) + " milliseconds..."
				Delay(this\number * 100)
				Debug "Thread " + this\number + " done!"
				MethodReturn(this\number)
			EndMethod
	EndClass
	
	Dim threads.type(Pusher)(#threads - 1)
	Define i.i
	
	; Erstelle Thread-Objekte
	For i = 0 To #threads - 1
		threads(i) = Pusher::init(i + 1)
	Next
	
	; Starte alle Threads
	For i = 0 To #threads - 1
		threads(i)\start()
	Next
	
	; Warte auf Beendigung der Threads
	For i = 0 To #threads - 1
		Debug "Thread " + threads(i)\join() + " joined."
	Next
	
	; Gib alle Threads wieder frei
	For i = 0 To #threads - 1
		threads(i)\free()
	Next
	
CompilerEndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 28
; FirstLine = 16
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; CompileSourceDirectory
; EnablePurifier