﻿XIncludeFile "InputStream.pbi"

; See: http://docs.oracle.com/javase/7/docs/api/java/io/FilterInputStream.html
Class(FilterInputStream, InputStream)
		; does nothing
		;close.i()
		
		; bytes available for reading
		;available.q()
		
		; reads size byes from the stream into *buffer.
		; returns bytes copied or -1 if end of stream was reached.
		;readBuffer.i(*buffer, size.i)
		
		; skips a certain amount of bytes.
		;skip.q(bytes.q)
		
		; marks a position in the stream to which can be jumped with reset
		; initially 0. readLimit is ignored.
		;mark(readLimit.q)
		
		; returns true
		;markSupported.i()
		
		; jumps to the marked position.
		;reset()
	Members
		is.type(InputStream)
	Constructors
		Construct(createFrom,(is.type(InputStream)))
	Definition
		Constructor(createFrom,(is.type(InputStream)))
			this\is = is
		EndConstructor
		
		Synchronized(i, close,(this))
			SynchronizedReturn(this\is\close())
		EndSynchronized
		
		Synchronized(q, available,(this))
			SynchronizedReturn(this\is\available())
		EndSynchronized
		
		Synchronized(i, readBuffer,(this, *buffer, size.i))
			SynchronizedReturn(this\is\readBuffer(*buffer, size))
		EndSynchronized
		
		Synchronized(q, skip,(this, bytes.q))
			SynchronizedReturn(this\is\skip(bytes))
		EndSynchronized
		
		Synchronized(i, mark,(this, readLimit.q))
			SynchronizedReturn(this\is\mark(readLimit))
		EndSynchronized
		
		Synchronized(i, markSupported,(this))
			SynchronizedReturn(this\is\markSupported())
		EndSynchronized
		
		Synchronized(i, reset,(this))
			SynchronizedReturn(this\is\reset())
		EndSynchronized
EndClass
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 62
; FirstLine = 23
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; EnablePurifier